<?php

/* NoPro sql-lib
 * some handy funcs using mysqli-object
 */

/***
 * 2015-08-22 sqlistore() now handles an array as $idkey
 * 2015-09-20 added sqli2out()
 */

function sqlistore($dbo, $tbl, $arr, $idkey = null, $verbose = false, $keys = null) {
  /* the presence of $idkey, signals UPDATE instead of INSERT
   * $verbose means to print the query
   * $keys for non-associative $arr, or to override $k from $arr
   */
  $query = $idkey ? "UPDATE $tbl SET" : "INSERT INTO $tbl SET";
  foreach($arr as $k => $val) {
    $key = $keys ? $keys[$k] : $k;
    if($key == $idkey || (is_array($idkey) && in_array($key, $idkey)))
      continue;
    if(is_numeric($val))
      $query .= " `$key` = $val,";
    else if($val === null)
      $query .= " `$key` = NULL,";
    else
      $query .= " `$key` = '$val',";
  }
  $query = rtrim($query, ',');
  
  if($idkey) {
    if(is_array($idkey)) {
      $query .= 'WHERE';
      foreach($idkey as $k) {
	$query .= " `$k` = '$arr[$k]' AND";
      }
      $query = substr($query, 0, strlen($query) - 4);
    } else {
      $query .= sprintf(" WHERE `$idkey` = '%s'", $arr[$idkey]);
    }
  }
  
  if($verbose)
    echo $query ."\n";
  #die($query);
  
  $dbo->query($query) OR die("sqlistore(): ". $dbo->error);
  #return ($idkey && !is_array($idkey)) ? $arr[$idkey] : $dbo->insert_id;
}

function sqli2arr($dbo, $query) {
  // fill array with sql-results
  $arr = array();
  $res = $dbo->query($query) OR die("query(): ".$dbo->error);
  while($row = $res->fetch_assoc()) {
    array_push($arr, $row);
  }
  $res->close();
  return $arr;
}

function sqli2arr1d($dbo, $query) {
  // fill 1d-array with sql-results
  $arr = array();
  $res = $dbo->query($query) OR die("query(): ".$dbo->error);
  while($row = $res->fetch_row()) {
    array_push($arr, $row[0]);
  }
  $res->close();
  return $arr;
}
function sqli_tables($dbo) { return sqli2arr1d($dbo, 'SHOW TABLES'); }


/////
// following is exclusive to nopro_sqli
// no more further support of nopro_sql
/////


function sqli_coll($dbo, $query, $dim = 1) {
  // return array ('collection') as result of query
  return $dim > 1 ? sqli2arr($dbo, $query) : sqli2arr1d($dbo, $query);
}
  
function sqli_roster($dbo, $tbl) {
  // return array of fname => ftyype
  $ret = array();
  $xpl = sqli2arr($dbo, "EXPLAIN $tbl");   // DESCRIBE table
  foreach($xpl as $arr) {
    $ret[$arr['Field']] = $arr['Type'];
  }
  return $ret;
}

function sqli_q2csv($dbo, $q, $out = '/dev/stdout') {
  // output query-result as csv
  $res = $dbo->query($q);
  if($res !== false && $res->num_rows > 0) {
    $fh = fopen($out, 'w') OR die("fopen($out)");
    $row = $res->fetch_assoc();
    fputcsv($fh, array_keys($row));
    fputcsv($fh, array_values($row));
    while($row = $res->fetch_assoc()) {
      fputcsv($fh, $row);
    }
    fclose($fh);  
    $res->close();
  }
}

function sqli2out($dbo, $query) {
  // echo sql-results
  $res = $dbo->query($query) OR die("query(): ".$dbo->error);
  $head = '';
  while($row = $res->fetch_assoc()) {
    $line = '';
    foreach($row as $k => $v) {
      if($head !== false)
	$head .= "\t$k";
      $line .= "\t$v";
    }
    if($head !== false) {
      echo $head.LF;
      $head = false;
    }
    echo $line.LF;
  }
  $res->close();
}

function sql_setXchecks($dbo, $on) {
  // switch foreign key-checks 
  if(!$on)
    $dbo->query("SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0");
  else
    $dbo->query("SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS");
}

?>